diff --git a/pyanaconda/storage/devicelibs/lvm.py b/pyanaconda/storage/devicelibs/lvm.py
index 2638ec7..7691993 100644
--- a/pyanaconda/storage/devicelibs/lvm.py
+++ b/pyanaconda/storage/devicelibs/lvm.py
@@ -24,12 +24,12 @@ import os
 import math
 import re
 
-from pyanaconda import iutil
 import logging
 log = logging.getLogger("storage")
 
+from .. import util
+from .. import arch
 from ..errors import *
-from pyanaconda.constants import *
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -41,7 +41,7 @@ LVM_PE_START = 1.0      # MB
 LVM_PE_SIZE = 4.0       # MB
 
 def has_lvm():
-    if iutil.find_program_in_path("lvm"):
+    if util.find_program_in_path("lvm"):
         for line in open("/proc/devices").readlines():
             if "device-mapper" in line.split():
                 return True
@@ -134,7 +134,7 @@ def getPossiblePhysicalExtents(floor=0):
 
 def getMaxLVSize():
     """ Return the maximum size (in MB) of a logical volume. """
-    if iutil.getArch() in ("x86_64", "ppc64", "alpha", "ia64", "s390", "sparc"): #64bit architectures
+    if arch.getArch() in ("x86_64", "ppc64", "alpha", "ia64", "s390", "sparc"): #64bit architectures
         return (8*1024*1024*1024*1024) #Max is 8EiB (very large number..)
     else:
         return (16*1024*1024) #Max is 16TiB
@@ -158,7 +158,7 @@ def get_pv_space(size, disks, pesize=LVM_PE_SIZE,
     return space
 
 def lvm(args):
-    ret = iutil.execWithRedirect("lvm", args)
+    ret = util.run_program(["lvm"] + args)
     if ret:
         raise LVMError("running lvm " + " ".join(args) + " failed")
 
@@ -212,7 +212,7 @@ def pvinfo(device):
             config_args + \
             [device]
 
-    rc = iutil.execWithCapture("lvm", args)
+    rc = util.capture_output(["lvm"] + args)
     vals = rc.split()
     if not vals:
         raise LVMError("pvinfo failed for %s" % device)
@@ -299,7 +299,7 @@ def vginfo(vg_name):
             config_args + \
             [vg_name]
 
-    buf = iutil.execWithCapture("lvm", args)
+    buf = util.capture_output(["lvm"] + args)
     info = buf.split()
     if len(info) != 7:
         raise LVMError(_("vginfo failed for %s" % vg_name))
@@ -316,7 +316,7 @@ def lvs(vg_name):
             config_args + \
             [vg_name]
 
-    buf = iutil.execWithCapture("lvm", args)
+    buf = util.capture_output(["lvm"] + args)
 
     lvs = {}
     for line in buf.splitlines():
@@ -338,7 +338,7 @@ def lvorigin(vg_name, lv_name):
             config_args + \
             ["%s/%s" % (vg_name, lv_name)]
 
-    buf = iutil.execWithCapture("lvm", args)
+    buf = util.capture_output(["lvm"] + args)
 
     try:
         origin = buf.splitlines()[0].strip()
diff --git a/pyanaconda/storage/devicelibs/mdraid.py b/pyanaconda/storage/devicelibs/mdraid.py
index f8e93d5..ab18641 100644
--- a/pyanaconda/storage/devicelibs/mdraid.py
+++ b/pyanaconda/storage/devicelibs/mdraid.py
@@ -22,7 +22,7 @@
 
 import os
 
-from pyanaconda import iutil
+from .. import util
 from ..errors import *
 
 import gettext
@@ -169,7 +169,7 @@ def get_member_space(size, disks, level=None):
     return space * disks
 
 def mdadm(args):
-    ret = iutil.execWithRedirect("mdadm", args)
+    ret = util.run_program(["mdadm"] + args)
     if ret:
         raise MDRaidError("running mdadm " + " ".join(args) + " failed")
 
@@ -233,17 +233,17 @@ def mddeactivate(device):
         raise MDRaidError("mddeactivate failed for %s: %s" % (device, msg))
 
 def mdexamine(device):
-    vars = iutil.execWithCapture("mdadm",
-                                 ["--examine", "--brief", device]).split()
+    _vars = util.capture_output(["mdadm",
+                                 "--examine", "--brief", device]).split()
 
     info = {}
-    if len(vars) > 1 and vars[1].startswith("/dev/md"):
-        info["device"] = vars[1]
-        vars = vars[2:]
-    elif len(vars) > 1:
-        vars = vars[1:]
+    if len(_vars) > 1 and _vars[1].startswith("/dev/md"):
+        info["device"] = _vars[1]
+        _vars = _vars[2:]
+    elif len(_vars) > 1:
+        _vars = _vars[1:]
 
-    for var in vars:
+    for var in _vars:
         (name, equals, value) = var.partition("=")
         if not equals:
             continue
diff --git a/pyanaconda/storage/devicelibs/mpath.py b/pyanaconda/storage/devicelibs/mpath.py
index 2e5efd1..d49ab07 100644
--- a/pyanaconda/storage/devicelibs/mpath.py
+++ b/pyanaconda/storage/devicelibs/mpath.py
@@ -2,9 +2,9 @@
 import re
 
 from ..udev import udev_device_is_disk
-from pyanaconda import iutil
-from pyanaconda.flags import flags
-from pyanaconda.anaconda_log import log_method_call
+from .. import util
+from ..flags import flags
+from ..storage_log import log_method_call
 
 import logging
 log = logging.getLogger("storage")
@@ -106,9 +106,9 @@ class MultipathTopology(object):
             map(lambda line: log.debug(line.rstrip()), conf)
             log.debug("(end of /etc/multipath.conf)")
         self._mpath_topology = parseMultipathOutput(
-            iutil.execWithCapture("multipath", ["-d",]))
+            util.capture_output(["multipath", "-d"]))
         self._mpath_topology.update(parseMultipathOutput(
-                iutil.execWithCapture("multipath", ["-ll",])))
+            util.capture_output(["multipath", "-ll"])))
 
         delete_keys = []
         for (mp, disks) in self._mpath_topology.items():
@@ -268,7 +268,7 @@ blacklist {
         return ret
 
     def writeConfig(self, friendly_names=True):
-        if not flags.mpath:
+        if not flags.multipath:
             # not writing out a multipath.conf will effectively blacklist all
             # mpath which will prevent any of them from being activated during
             # install
@@ -279,7 +279,7 @@ blacklist {
             mpath_cfg.write(cfg)
 
 def flush_mpaths():
-    iutil.execWithRedirect("multipath", ["-F"])
-    check_output = iutil.execWithCapture("multipath", ["-ll"]).strip()
+    util.run_program(["multipath", "-F"])
+    check_output = util.capture_output(["multipath", "-ll"]).strip()
     if check_output:
         log.error("multipath: some devices could not be flushed")
diff --git a/pyanaconda/storage/devicelibs/swap.py b/pyanaconda/storage/devicelibs/swap.py
index b96aefe..4c9490a 100644
--- a/pyanaconda/storage/devicelibs/swap.py
+++ b/pyanaconda/storage/devicelibs/swap.py
@@ -21,18 +21,17 @@
 #
 
 import resource
-
-from pyanaconda import iutil
 import os
 
 from ..errors import *
+from .. import util
 from . import dm
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
 
 import logging
-log = logging.getLogger("anaconda")
+log = logging.getLogger("storage")
 
 def mkswap(device, label=''):
     # We use -f to force since mkswap tends to refuse creation on lvs with
@@ -42,7 +41,7 @@ def mkswap(device, label=''):
         argv.extend(["-L", label])
     argv.append(device)
 
-    ret = iutil.execWithRedirect("mkswap", argv)
+    ret = util.run_program(["mkswap"] + argv)
 
     if ret:
         raise SwapError("mkswap failed for '%s'" % device)
@@ -83,13 +82,13 @@ def swapon(device, priority=None):
         argv.extend(["-p", "%d" % priority])
     argv.append(device)
         
-    rc = iutil.execWithRedirect("swapon", argv)
+    rc = util.run_program(["swapon"] + argv)
 
     if rc:
         raise SwapError("swapon failed for '%s'" % device)
 
 def swapoff(device):
-    rc = iutil.execWithRedirect("swapoff", [device])
+    rc = util.run_program(["swapoff", device])
 
     if rc:
         raise SwapError("swapoff failed for '%s'" % device)
@@ -127,7 +126,7 @@ def swapSuggestion(quiet=False, hibernation=False):
 
     """
 
-    mem = iutil.memInstalled()/1024
+    mem = util.total_memory()/1024
     mem = ((mem/16)+1)*16
     if not quiet:
         log.info("Detected %sM of memory", mem)
diff --git a/pyanaconda/storage/devices.py b/pyanaconda/storage/devices.py
index d3897d0..56f871a 100644
--- a/pyanaconda/storage/devices.py
+++ b/pyanaconda/storage/devices.py
@@ -111,9 +111,10 @@ import _ped
 import block
 
 from errors import *
-from pyanaconda.iutil import notify_kernel, numeric_type
-from pyanaconda.flags import flags
-from pyanaconda.anaconda_log import log_method_call
+import util
+import arch
+from flags import flags
+from storage_log import log_method_call
 from udev import *
 from formats import get_device_format_class, getFormat, DeviceFormat
 
@@ -474,9 +475,9 @@ class StorageDevice(Device):
 
         self.uuid = uuid
         self._format = None
-        self._size = numeric_type(size)
-        self.major = numeric_type(major)
-        self.minor = numeric_type(minor)
+        self._size = util.numeric_type(size)
+        self.major = util.numeric_type(major)
+        self.minor = util.numeric_type(minor)
         self.sysfsPath = sysfsPath
         self._serial = serial
         self._vendor = vendor
@@ -665,7 +666,7 @@ class StorageDevice(Device):
 
         path = os.path.normpath("/sys/%s" % self.sysfsPath)
         try:
-            notify_kernel(path, action="change")
+            util.notify_kernel(path, action="change")
         except (ValueError, IOError) as e:
             log.warning("failed to notify kernel of change: %s" % e)
 
@@ -1169,7 +1170,7 @@ class PartitionDevice(StorageDevice):
             self.req_name = name
             self.req_partType = partType
             self.req_primary = primary
-            self.req_max_size = numeric_type(maxsize)
+            self.req_max_size = util.numeric_type(maxsize)
             self.req_grow = grow
             self.req_bootable = bootable
 
@@ -1376,7 +1377,7 @@ class PartitionDevice(StorageDevice):
     def _setBootable(self, bootable):
         """ Set the bootable flag for this partition. """
         if self.partedPartition:
-            if iutil.isS390():
+            if arch.isS390():
                 return
             if self.flagAvailable(parted.PARTITION_BOOT):
                 if bootable:
@@ -1765,16 +1766,14 @@ class DMDevice(StorageDevice):
 
     def setupPartitions(self):
         log_method_call(self, name=self.name, kids=self.kids)
-        rc = iutil.execWithRedirect("kpartx",
-                                ["-a", "-s", self.path])
+        rc = util.run_program(["kpartx", "-a", "-s", self.path])
         if rc:
             raise DMError("partition activation failed for '%s'" % self.name)
         udev_settle()
 
     def teardownPartitions(self):
         log_method_call(self, name=self.name, kids=self.kids)
-        rc = iutil.execWithRedirect("kpartx",
-                                ["-d", "-s", self.path])
+        rc = util.run_program(["kpartx", "-d", "-s", self.path])
         if rc:
             raise DMError("partition deactivation failed for '%s'" % self.name)
         udev_settle()
@@ -1985,11 +1984,11 @@ class LVMVolumeGroupDevice(DMDevice):
                           exists=exists, sysfsPath=sysfsPath)
 
         self.uuid = uuid
-        self.free = numeric_type(free)
-        self.peSize = numeric_type(peSize)
-        self.peCount = numeric_type(peCount)
-        self.peFree = numeric_type(peFree)
-        self.pvCount = numeric_type(pvCount)
+        self.free = util.numeric_type(free)
+        self.peSize = util.numeric_type(peSize)
+        self.peCount = util.numeric_type(peCount)
+        self.peFree = util.numeric_type(peFree)
+        self.pvCount = util.numeric_type(pvCount)
         self.lv_names = []
         self.lv_uuids = []
         self.lv_sizes = []
@@ -2321,7 +2320,7 @@ class LVMVolumeGroupDevice(DMDevice):
 
     def align(self, size, roundup=None):
         """ Align a size to a multiple of physical extent size. """
-        size = numeric_type(size)
+        size = util.numeric_type(size)
 
         if roundup:
             round = math.ceil
@@ -2425,10 +2424,10 @@ class LVMLogicalVolumeDevice(DMDevice):
 
         if not self.exists:
             self.req_grow = grow
-            self.req_max_size = numeric_type(maxsize)
+            self.req_max_size = util.numeric_type(maxsize)
             # XXX should we enforce that req_size be pe-aligned?
             self.req_size = self._size
-            self.req_percent = numeric_type(percent)
+            self.req_percent = util.numeric_type(percent)
 
         if self.singlePV:
             # make sure there is at least one PV that can hold this LV
@@ -2471,7 +2470,7 @@ class LVMLogicalVolumeDevice(DMDevice):
         return self.stripes > 1
 
     def _setSize(self, size):
-        size = self.vg.align(numeric_type(size))
+        size = self.vg.align(util.numeric_type(size))
         log.debug("trying to set lv %s size to %dMB" % (self.name, size))
         if size <= self.vg.freeSpace + self.vgSpaceUsed:
             self._size = size
@@ -2671,8 +2670,8 @@ class MDRaidArrayDevice(StorageDevice):
                                  {"raidLevel": self.level, "minMembers": mdraid.get_raid_min_members(self.level)}
 
         self.uuid = uuid
-        self._totalDevices = numeric_type(totalDevices)
-        self._memberDevices = numeric_type(memberDevices)
+        self._totalDevices = util.numeric_type(totalDevices)
+        self._memberDevices = util.numeric_type(memberDevices)
 
         self.chunkSize = 512.0 / 1024.0         # chunk size in MB
 
@@ -3372,8 +3371,7 @@ class MultipathDevice(DMDevice):
         """
         if self.exists and os.path.exists(self.path):
             #self.teardownPartitions()
-            #rc = iutil.execWithRedirect("multipath",
-            #                    ['-f', self.name])
+            #rc = util.run_program(["multipath", '-f', self.name])
             #if rc:
             #    raise MPathError("multipath deactivation failed for '%s'" %
             #                    self.name)
@@ -3392,8 +3390,7 @@ class MultipathDevice(DMDevice):
         log_method_call(self, self.name, orig=orig, status=self.status,
                         controllable=self.controllable)
         udev_settle()
-        rc = iutil.execWithRedirect("multipath",
-                            [self.name])
+        rc = util.run_program(["multipath", self.name])
         if rc:
             raise MPathError("multipath activation failed for '%s'" %
                             self.name, hardware_fault=True)
@@ -3555,7 +3552,7 @@ class DirectoryDevice(FileDevice):
     def _create(self):
         """ Create the device. """
         log_method_call(self, self.name, status=self.status)
-        iutil.mkdirChain(self.path)
+        util.makedirs(self.path)
 
 
 class LoopDevice(StorageDevice):
@@ -3775,8 +3772,6 @@ class OpticalDevice(StorageDevice):
 
     def eject(self):
         """ Eject the drawer. """
-        from pyanaconda import _isys
-
         log_method_call(self, self.name, status=self.status)
         if not self.exists:
             raise DeviceError("device has not been created", self.name)
@@ -3788,17 +3783,11 @@ class OpticalDevice(StorageDevice):
             log.info("noeject in effect, not ejecting cdrom")
             return
 
-        # Make a best effort attempt to do the eject.  If it fails, it's not
-        # critical.
-        fd = os.open(self.path, os.O_RDONLY | os.O_NONBLOCK)
-
         try:
-            _isys.ejectcdrom(fd)
-        except SystemError as e:
+            util.run_program(["eject", self.name]) 
+        except OSError as e:
             log.warning("error ejecting cdrom %s: %s" % (self.name, e))
 
-        os.close(fd)
-
 
 class ZFCPDiskDevice(DiskDevice):
     """ A mainframe ZFCP disk. """
diff --git a/pyanaconda/storage/devicetree.py b/pyanaconda/storage/devicetree.py
index 578671f..0a5e7cd 100644
--- a/pyanaconda/storage/devicetree.py
+++ b/pyanaconda/storage/devicetree.py
@@ -40,11 +40,11 @@ import devicelibs.mpath
 import devicelibs.loop
 import devicelibs.edd
 from udev import *
-from pyanaconda import iutil
+import util
 from pyanaconda import platform
 from pyanaconda import tsort
-from pyanaconda.flags import flags
-from pyanaconda.anaconda_log import log_method_call, log_method_return
+from flags import flags
+from storage_log import log_method_call, log_method_return
 import parted
 import _ped
 
@@ -534,7 +534,7 @@ class DeviceTree(object):
              udev_device_is_dm_crypt(info) or
              (udev_device_is_md(info) and not
               udev_device_get_md_container(info)))):
-            if iutil.get_sysfs_attr(info["sysfs_path"], 'ro') == '1':
+            if util.get_sysfs_attr(info["sysfs_path"], 'ro') == '1':
                 log.debug("Ignoring read only device %s" % name)
                 self.addIgnoredDisk(name)
                 return True
@@ -1599,7 +1599,7 @@ class DeviceTree(object):
     def updateDeviceFormat(self, device):
         log.info("updating format of device: %s" % device)
         try:
-            iutil.notify_kernel("/sys%s" % device.sysfsPath)
+            util.notify_kernel("/sys%s" % device.sysfsPath)
         except (ValueError, IOError) as e:
             log.warning("failed to notify kernel of change: %s" % e)
 
@@ -2189,10 +2189,10 @@ class DeviceTree(object):
             attr = None
             if "subvol=" in options:
                 attr = "name"
-                val = iutil.get_option_value("subvol", options)
+                val = util.get_option_value("subvol", options)
             elif "subvolid=" in options:
                 attr = "vol_id"
-                val = iutil.get_option_value("subvolid", options)
+                val = util.get_option_value("subvolid", options)
 
             if attr and val:
                 for subvol in device.subvolumes:
diff --git a/pyanaconda/storage/fcoe.py b/pyanaconda/storage/fcoe.py
index e839f10..3a4d147 100644
--- a/pyanaconda/storage/fcoe.py
+++ b/pyanaconda/storage/fcoe.py
@@ -18,13 +18,13 @@
 #
 
 import os
-from pyanaconda import iutil
+from . import util
+from pyanaconda.baseudev import udev_settle
 from pyanaconda import isys
 from pyanaconda.constants import ROOT_PATH
 import logging
 import time
-from pyanaconda.flags import flags
-log = logging.getLogger("anaconda")
+log = logging.getLogger("storage")
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -34,11 +34,11 @@ _fcoe_module_loaded = False
 def has_fcoe():
     global _fcoe_module_loaded
     if not _fcoe_module_loaded:
-        iutil.execWithRedirect("modprobe", [ "fcoe" ])
+        util.run_program(["modprobe", "fcoe"])
         _fcoe_module_loaded = True
-        if "bnx2x" in iutil.lsmod():
+        if "bnx2x" in util.lsmod():
             log.info("fcoe: loading bnx2fc")
-            iutil.execWithRedirect("modprobe", [ "bnx2fc" ])
+            util.run_program(["modprobe", "bnx2fc"])
 
     return os.access("/sys/module/fcoe", os.X_OK)
 
@@ -67,10 +67,10 @@ class fcoe(object):
     def _stabilize(self):
         # I have no clue how long we need to wait, this ought to do the trick
         time.sleep(10)
-        iutil.execWithRedirect("udevadm", [ "settle" ])
+        udev_settle()
 
     def _startEDD(self):
-        rc = iutil.execWithCapture("/usr/libexec/fcoe/fcoe_edd.sh", [ "-i" ])
+        rc = util.capture_output(["/usr/libexec/fcoe/fcoe_edd.sh", "-i"])
         if not rc.startswith("NIC="):
             log.info("No FCoE EDD info found: %s" % rc.rstrip())
             return
@@ -97,7 +97,7 @@ class fcoe(object):
         if self.lldpadStarted:
             return
 
-        iutil.execWithRedirect("lldpad", [ "-d" ])
+        util.run_program(["lldpad", "-d"])
         self.lldpadStarted = True
 
     def addSan(self, nic, dcb=False, auto_vlan=True):
@@ -107,20 +107,20 @@ class fcoe(object):
         log.info("Activating FCoE SAN attached to %s, dcb: %s autovlan: %s" %
                  (nic, dcb, auto_vlan))
 
-        iutil.execWithRedirect("ip", [ "link", "set", nic, "up" ])
+        util.run_program(["ip", "link", "set", nic, "up"])
 
         if dcb:
             self._startLldpad()
-            iutil.execWithRedirect("dcbtool", [ "sc", nic, "dcb", "on" ])
-            iutil.execWithRedirect("dcbtool", [ "sc", nic, "app:fcoe",
-                                                "e:1", "a:1", "w:1" ])
-            iutil.execWithRedirect("fipvlan", [ "-c", "-s", "-f",
+            util.run_program(["dcbtool", "sc", nic, "dcb", "on"])
+            util.run_program(["dcbtool", "sc", nic, "app:fcoe",
+                                                "e:1", "a:1", "w:1"])
+            util.run_program(["fipvlan", "-c", "-s", "-f",
                                                "'-fcoe'", nic])
         else:
             if auto_vlan:
                 # certain network configrations require the VLAN layer module:
-                iutil.execWithRedirect("modprobe", ["8021q"])
-                iutil.execWithRedirect("fipvlan", ['-c', '-s', '-f',
+                util.run_program(["modprobe", "8021q"])
+                util.run_program(["fipvlan", '-c', '-s', '-f',
                                                    "'-fcoe'",  nic])
             else:
                 f = open("/sys/module/libfcoe/parameters/create", "w")
diff --git a/pyanaconda/storage/flags.py b/pyanaconda/storage/flags.py
new file mode 100644
index 0000000..ed0e5dc
--- /dev/null
+++ b/pyanaconda/storage/flags.py
@@ -0,0 +1,98 @@
+# flags.py
+#
+# Copyright (C) 2013  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): David Lehman <dlehman@redhat.com>
+#
+
+import shlex
+import selinux
+
+class Flags(object):
+    def __init__(self):
+        #
+        # mode of operation
+        #
+        self.testing = False
+        self.installer_mode = False
+
+        #
+        # minor modes (installer-specific)
+        #
+        self.automated_install = False
+        self.live_install = False
+        self.image_install = False
+
+        #
+        # enable/disable functionality
+        #
+        self.selinux = selinux.is_selinux_enabled()
+        self.multipath = True
+        self.dmraid = True
+        self.ibft = False
+        self.noiswmd = False
+
+        self.gfs2 = True
+        self.jfs = True
+        self.reiserfs = True
+
+        self.arm_platform = None
+
+        self.gpt = False
+
+        self.boot_cmdline = {}
+
+        self.update_from_boot_cmdline()
+
+    def get_boot_cmdline(self):
+        buf = open("/proc/cmdline").read().strip()
+        args = shlex.split(buf)
+        for arg in args:
+            (opt, equals, val) = arg.partition("=")
+            self.boot_cmdline[opt] = val
+
+    def update_from_boot_cmdline(self):
+        self.get_boot_cmdline()
+        if "nompath" in self.boot_cmdline:
+            self.multipath = False
+
+        if "nodmraid" in self.boot_cmdline:
+            self.dmraid = False
+
+        if "ibft" in self.boot_cmdline:
+            self.ibft = True
+
+        if "noiswmd" in self.boot_cmdline:
+            self.noiswmd = True
+
+    def update_from_anaconda_flags(self, anaconda_flags):
+        self.installer_mode = True
+        self.testing = anaconda_flags.testing
+        self.automated_install = anaconda_flags.automatedInstall
+        self.live_install = anaconda_flags.livecdInstall
+
+        self.selinux = anaconda_flags.selinux
+
+        self.gfs2 = "gfs2" in self.boot_cmdline
+        self.jfs = "jfs" in self.boot_cmdline
+        self.reiserfs = "reiserfs" in self.boot_cmdline
+
+        self.arm_platform = anaconda_flags.armPlatform
+        self.gpt = anaconda_flags.gpt
+
+
+flags = Flags()
diff --git a/pyanaconda/storage/formats/__init__.py b/pyanaconda/storage/formats/__init__.py
index 532855a..62bfb31 100644
--- a/pyanaconda/storage/formats/__init__.py
+++ b/pyanaconda/storage/formats/__init__.py
@@ -24,10 +24,10 @@ import os
 
 from pyanaconda.product import productName
 from pyanaconda.baseudev import udev_get_device
-from pyanaconda.iutil import notify_kernel
-from pyanaconda.iutil import get_sysfs_path_by_name
-from pyanaconda.iutil import execWithRedirect
-from pyanaconda.anaconda_log import log_method_call
+from ..util import notify_kernel
+from ..util import get_sysfs_path_by_name
+from ..util import run_program
+from ..storage_log import log_method_call
 from ..errors import *
 from ..devicelibs.dm import dm_node_from_name
 from ..devicelibs.mdraid import md_node_from_name
@@ -309,8 +309,8 @@ class DeviceFormat(object):
         log_method_call(self, device=self.device,
                         type=self.type, status=self.status)
         try:
-            rc = execWithRedirect("wipefs", ["-a", self.device])
-        except Exception as e:
+            rc = run_program(["wipefs", "-a", self.device])
+        except OSError as e:
             err = str(e)
         else:
             err = ""
diff --git a/pyanaconda/storage/formats/disklabel.py b/pyanaconda/storage/formats/disklabel.py
index 7a8c18b..018adf4 100644
--- a/pyanaconda/storage/formats/disklabel.py
+++ b/pyanaconda/storage/formats/disklabel.py
@@ -23,13 +23,12 @@
 import os
 import copy
 
-from pyanaconda.flags import flags
-
-from pyanaconda.anaconda_log import log_method_call
-from pyanaconda import iutil
+from ..storage_log import log_method_call
 import parted
 import _ped
 from ..errors import *
+from .. import arch
+from ..flags import flags
 from ..udev import udev_settle
 from . import DeviceFormat, register_device_format
 
@@ -172,7 +171,7 @@ class DiskLabel(DeviceFormat):
             # Set the boot flag on the GPT PMBR, this helps some BIOS systems boot
             if self._partedDisk.isFlagAvailable(parted.DISK_GPT_PMBR_BOOT):
                 # MAC can boot as EFI or as BIOS, neither should have PMBR boot set
-                if iutil.isEfi() or iutil.isMactel():
+                if arch.isEfi() or arch.isMactel():
                     self._partedDisk.unsetFlag(parted.DISK_GPT_PMBR_BOOT)
                     log.debug("Clear pmbr_boot on %s" % (self._partedDisk,))
                 else:
diff --git a/pyanaconda/storage/formats/dmraid.py b/pyanaconda/storage/formats/dmraid.py
index 37624af..f37b2d3 100644
--- a/pyanaconda/storage/formats/dmraid.py
+++ b/pyanaconda/storage/formats/dmraid.py
@@ -20,8 +20,8 @@
 # Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
 #
 
-from pyanaconda.anaconda_log import log_method_call
-from pyanaconda.flags import flags
+from ..storage_log import log_method_call
+from ..flags import flags
 from ..errors import *
 from . import DeviceFormat, register_device_format
 
@@ -102,12 +102,12 @@ class DMRaidMember(DeviceFormat):
         raise DMRaidMemberError("destruction of dmraid members is non-sense")
 
 
-if not flags.cmdline.has_key("noiswmd"):
+if not flags.noiswmd:
     DMRaidMember._udevTypes.remove("isw_raid_member")
 
 # The anaconda cmdline has not been parsed yet when we're first imported,
 # so we can not use flags.dmraid here
-if flags.cmdline.has_key("nodmraid"):
+if not flags.dmraid:
     DMRaidMember._udevTypes = []
 
 register_device_format(DMRaidMember)
